#pragma once

#define MAX_MODE_NAME 260
#define MAX_THEME_NAME 32

#define COLOR_GENERAL 0
#define COLOR_SELECTION 1
#define COLOR_CURRENT_LINE 2
#define COLOR_HYPERLINK 3
#define COLOR_STRING 4
#define COLOR_COMMENT 5
#define COLOR_SCRIPT 6
#define COLOR_BRACKET 7
#define COLOR_TAG 8
#define COLOR_KEYWORD_1 9
#define COLOR_KEYWORD_2 10
#define COLOR_KEYWORD_3 11
#define COLOR_KEYWORD_4 12
#define COLOR_KEYWORD_5 13
#define COLOR_KEYWORD_6 14
#define COLOR_KEYWORD_7 15
#define COLOR_KEYWORD_8 16
#define COLOR_CRLF 17
#define COLOR_WRAP 18
#define COLOR_TAB 19
#define COLOR_EOF 20
#define COLOR_CARET_LINE 21
#define COLOR_LINE_NUMBERS 22
#define COLOR_RULER 23
#define COLOR_VERTICAL_LINE 24
#define COLOR_SB_ALPHABETIC 25
#define COLOR_SB_NUMBER 26
#define COLOR_SB_SYMBOL 27
#define COLOR_SB_KATAKANA 28
#define COLOR_SB_SPACE 29
#define COLOR_DB_ALPHABET 30
#define COLOR_DB_NUMBER 31
#define COLOR_DB_SYMBOL 32
#define COLOR_DB_HIRAGANA 33
#define COLOR_DB_KATAKANA 34
#define COLOR_DB_KANJI 35
#define COLOR_DB_SPACE 36
#define COLOR_BOOKMARK 37
#define COLOR_SEARCH_STRING 38
#define COLOR_FOREIGN 39
#define COLOR_OTHER 40
#define COLOR_CONTROL 41
#define COLOR_INVALID 42

#define CUSTOM_BAR_LEFT 0
#define CUSTOM_BAR_TOP 1
#define CUSTOM_BAR_RIGHT 2
#define CUSTOM_BAR_BOTTOM 3
#define MAX_CUSTOM_BAR 4

#define EVENT_CREATE 0x00000001
#define EVENT_CLOSE 0x00000002
#define EVENT_CREATE_FRAME 0x00000004
#define EVENT_CLOSE_FRAME 0x00000008
#define EVENT_SET_FOCUS 0x00000010
#define EVENT_KILL_FOCUS 0x00000020
#define EVENT_FILE_OPENED 0x00000040
#define EVENT_FILE_SAVED 0x00000080
#define EVENT_MODIFIED 0x00000100
#define EVENT_CARET_MOVED 0x00000200
#define EVENT_SCROLL 0x00000400
#define EVENT_SEL_CHANGED 0x00000800
#define EVENT_CHANGED 0x00001000
#define EVENT_CHAR 0x00002000
#define EVENT_MODE_CHANGED 0x00004000
#define EVENT_DOC_SEL_CHANGED 0x00008000
#define EVENT_DOC_CLOSE 0x00010000
#define EVENT_TAB_MOVED 0x00020000
#define EVENT_CUSTOM_BAR_CLOSING 0x00040000
#define EVENT_CUSTOM_BAR_CLOSED 0x00080000
#define EVENT_TOOL_BAR_CLOSED 0x00100000
#define EVENT_TOOL_BAR_SHOW 0x00200000
#define EVENT_IDLE 0x00400000

#define CLOSED_FRAME_WINDOW 1
#define CLOSED_ANOTHER_CUSTOM_BAR 2

#define ME_FIRST (WM_USER + 0x0400)
#define ME_NEW (ME_FIRST + 0)
#define ME_GET_CMD_ID (ME_FIRST + 1)
#define ME_QUERY_STATUS (ME_FIRST + 2)
#define ME_GET_SEL_TEXT (ME_FIRST + 3)
#define ME_GET_LINES (ME_FIRST + 4)
#define ME_GET_LINE (ME_FIRST + 5)
#define ME_GET_CARET_POS (ME_FIRST + 6)
#define ME_GET_SCROLL_POS (ME_FIRST + 7)
#define ME_LINE_FROM_CHAR (ME_FIRST + 8)
#define ME_LINE_INDEX (ME_FIRST + 9)
#define ME_LOAD_FILE (ME_FIRST + 10)
#define ME_LOGICAL_TO_SERIAL (ME_FIRST + 11)
#define ME_LOGICAL_TO_VIEW (ME_FIRST + 12)
#define ME_SAVE_FILE (ME_FIRST + 13)
#define ME_SERIAL_TO_LOGICAL (ME_FIRST + 14)
#define ME_SET_CARET_POS (ME_FIRST + 15)
#define ME_SET_SCROLL_POS (ME_FIRST + 16)
#define ME_VIEW_TO_LOGICAL (ME_FIRST + 17)
#define ME_EXEC_COMMAND (ME_FIRST + 18)
#define ME_GET_MODIFIED (ME_FIRST + 19)
#define ME_SET_MODIFIED (ME_FIRST + 20)
#define ME_GET_SEL_START (ME_FIRST + 21)
#define ME_GET_SEL_END (ME_FIRST + 22)
#define ME_SET_SEL_LENGTH (ME_FIRST + 23)
#define ME_GET_MODE (ME_FIRST + 24)
#define ME_SET_MODE (ME_FIRST + 25)
#define ME_EMPTY_UNDO_BUFFER (ME_FIRST + 26)
#define ME_INSERT_STRING (ME_FIRST + 27)
#define ME_SET_SEL_VIEW (ME_FIRST + 28)
#define ME_FIND (ME_FIRST + 29)
#define ME_REPLACE (ME_FIRST + 30)
#define ME_SET_STATUS (ME_FIRST + 31)
#define ME_CONVERT (ME_FIRST + 32)
#define ME_GET_MARGIN (ME_FIRST + 33)
#define ME_GET_VERSION (ME_FIRST + 34)
#define ME_REDRAW (ME_FIRST + 35)
#define ME_GET_SEL_TYPE (ME_FIRST + 36)
#define ME_IS_CHAR_HALF_OR_FULL (ME_FIRST + 37)
#define ME_INFO (ME_FIRST + 38)
#define ME_GET_STATUS (ME_FIRST + 39)
#define ME_CUSTOM_BAR_OPEN (ME_FIRST + 40)
#define ME_CUSTOM_BAR_CLOSE (ME_FIRST + 41)
#define ME_MATCH_REGEX (ME_FIRST + 42)
#define ME_FIND_REGEX (ME_FIRST + 43)
#define ME_ENUM_MODE (ME_FIRST + 44)
#define ME_TOOL_BAR_OPEN (ME_FIRST + 45)
#define ME_TOOL_BAR_CLOSE (ME_FIRST + 46)
#define ME_TOOL_BAR_SHOW (ME_FIRST + 47)
#define ME_OUTPUT_STRING (ME_FIRST + 48)
#define ME_GET_OUTPUT_STRING (ME_FIRST + 49)
#define ME_LAST (ME_FIRST + 255)

#define MI_GET_FILE_NAME 256
#define MI_GET_APP_VERSION 257
#define MI_IS_WINDOW_COMBINED 258
#define MI_WINDOW_COMBINE 259
#define MI_GET_DOC_COUNT 260
#define MI_INDEX_TO_DOC 261
#define MI_DOC_TO_INDEX 262
#define MI_GET_ACTIVE_INDEX 263
#define MI_SET_ACTIVE_INDEX 264
#define MI_GET_ACTIVE_DOC 265
#define MI_SET_ACTIVE_DOC 266
#define MI_CLOSE_DOC 267
#define MI_SAVE_DOC 268
#define MI_GET_FONT_NAME 269
#define MI_GET_FONT_CHARSET 270
#define MI_GET_FONT_SIZE 271
#define MI_GET_TEXT_COLOR 272
#define MI_GET_BACK_COLOR 273
#define MI_GET_INVERT_COLOR 274

#define OVERWRITE_PER_PROP 0
#define OVERWRITE_INSERT 1
#define OVERWRITE_OVERWRITE 2
#define OVERWRITE_MASK 3

#define FLAG_OPEN_OUTPUT 1
#define FLAG_CLOSE_OUTPUT 2
#define FLAG_FOCUS_OUTPUT 4
#define FLAG_CLEAR_OUTPUT 8

#define POS_VIEW 0
#define POS_LOGICAL 1
#define POS_DEV 2
#define MAX_LINE_COLUMN_MODE 4
#define SEL_TYPE_NONE 0
#define SEL_TYPE_CHAR 1
#define SEL_TYPE_BOX 2
#define FLAG_MAKE_LOWER 0
#define FLAG_MAKE_UPPER 1
#define FLAG_HAN_TO_ZEN 2
#define FLAG_ZEN_TO_HAN 3
#define FLAG_CAPITALIZE 4
#define FLAG_CONVERT_SELECT_ALL 0x0100
#define FLAG_FIND_NEXT 0x00000001
#define FLAG_REPLACE_ALL 0x00000002
#define FLAG_FIND_OPEN_DOC 0x00000004
#define FLAG_FIND_MATCH_CASE 0x00000008
#define FLAG_FIND_RECURSIVE 0x00000010
#define FLAG_FIND_REG_EX 0x00000020
#define FLAG_FIND_WHOLE_WORD 0x00000040
#define FLAG_FIND_AROUND 0x00000080
#define FLAG_REPLACE_SEL_ONLY 0x00000100
#define FLAG_FIND_CLOSE 0x00000200
#define FLAG_FIND_FILENAMES_ONLY 0x00000400
#define FLAG_REPLACE_BACKUP 0x00000800
#define FLAG_LOGICAL 1
#define FLAG_WITH_CRLF 2
#define FLAG_GET_CRLF_BYTE 4
#define FLAG_CR_ONLY 1
#define FLAG_LF_ONLY 2

#define MP_FIRST (WM_USER + 0x0500)
#define MP_QUERY_PROPERTIES (MP_FIRST + 0)
#define MP_SET_PROPERTIES (MP_FIRST + 1)
#define MP_GET_NAME (MP_FIRST + 2)
#define MP_GET_VERSION (MP_FIRST + 3)
#define MP_PRE_TRANSLATE_MSG (MP_FIRST + 4)
#define MP_LAST (MP_FIRST + 50)

#define MEID_NEW 2048
#define MEID_NEW_PASTE 2049
#define MEID_NEW_PASTE_QUOTES 2050
#define MEID_OPEN 2051
#define MEID_FIND_IN_FILES 2052
#define MEID_SAVE_ALL 2053
#define MEID_SAVE_CLOSE_ALL 2054
#define MEID_CLOSE_ALL 2055
#define MEID_CASCADE 2056
#define MEID_TILE_HORZ 2057
#define MEID_TILE_VERT 2058
#define MEID_MINIMIZE_ALL 2059
#define MEID_CLOSE_TRAY_ICON 2060
#define MEID_FILE_NEW 2061
#define MEID_FILE_OPEN 2062
#define MEID_FILE_CLOSE_OPEN 2063
#define MEID_FILE_SAVE 2064
#define MEID_FILE_SAVE_AS 2065
#define MEID_FILE_SAVE_ALL 2066
#define MEID_FILE_INSERT 2067
#define MEID_FILE_RELOAD_AUTO_SELECT 2068
#define MEID_FILE_RELOAD_UTF16LE 2069
#define MEID_FILE_RELOAD_UTF16BE 2070
#define MEID_FILE_RELOAD_UTF8 2071
#define MEID_FILE_RELOAD_UTF7 2072
#define MEID_FILE_RELOAD_ARABIC 2073
#define MEID_FILE_RELOAD_BALTIC 2074
#define MEID_FILE_RELOAD_CENTRAL_EUROPEAN 2075
#define MEID_FILE_RELOAD_CHINESE_SIMPLIFIED 2076
#define MEID_FILE_RELOAD_CHINESE_TRADITIONAL 2077
#define MEID_FILE_RELOAD_CYRILLIC 2078
#define MEID_FILE_RELOAD_GREEK 2079
#define MEID_FILE_RELOAD_HEBREW 2080
#define MEID_FILE_RELOAD_EUC 2081
#define MEID_FILE_RELOAD_JIS 2082
#define MEID_FILE_RELOAD_SHIFTJIS 2083
#define MEID_FILE_RELOAD_KOREAN 2084
#define MEID_FILE_RELOAD_THAI 2085
#define MEID_FILE_RELOAD_TURKISH 2086
#define MEID_FILE_RELOAD_VIETNAMESE 2087
#define MEID_FILE_RELOAD_WESTERN_EUROPEAN 2088
#define MEID_FILE_LINE_ENDING_CRLF 2089
#define MEID_FILE_LINE_ENDING_CR 2090
#define MEID_FILE_LINE_ENDING_LF 2091
#define MEID_FILE_PRINT 2092
#define MEID_FILE_PRINT_PREVIEW 2093
#define MEID_FILE_SAVE_CLOSE 2094
#define MEID_FILE_CLOSE 2095
#define MEID_FILE_SAVE_CLOSE_ALL 2096
#define MEID_FILE_CLOSE_ALL 2097
#define MEID_EDIT_UNDO 2098
#define MEID_EDIT_REDO 2099
#define MEID_EDIT_CUT 2100
#define MEID_EDIT_COPY 2101
#define MEID_EDIT_PASTE 2102
#define MEID_EDIT_COPY_QUOTES 2103
#define MEID_EDIT_DELETE 2104
#define MEID_EDIT_SELECT_ALL 2105
#define MEID_EDIT_DATE_TIME 2106
#define MEID_EDIT_GO_TO_LINE 2107
#define MEID_EDIT_GO_TO_FILE 2108
#define MEID_EDIT_READ_ONLY 2109
#define MEID_EDIT_INSERT_NEW_LINES 2110
#define MEID_EDIT_REMOVE_NEW_LINES 2111
#define MEID_EDIT_SPLIT_LINES 2112
#define MEID_EDIT_JOIN_LINES 2113
#define MEID_EDIT_UPPER_CASE 2114
#define MEID_EDIT_LOWER_CASE 2115
#define MEID_EDIT_CAPITALIZE 2116
#define MEID_EDIT_HALF_WIDTH 2117
#define MEID_EDIT_FULL_WIDTH 2118
#define MEID_EDIT_TABIFY 2119
#define MEID_EDIT_UNTABIFY 2120
#define MEID_EDIT_INDENT 2121
#define MEID_EDIT_UNINDENT 2122
#define MEID_EDIT_RECONVERT 2123
#define MEID_EDIT_BASE64_DECODE 2124
#define MEID_EDIT_INSERT 2125
#define MEID_EDIT_TOGGLE_BOOKMARK 2126
#define MEID_EDIT_NEXT_BOOKMARK 2127
#define MEID_EDIT_PREV_BOOKMARK 2128
#define MEID_EDIT_CLEAR_BOOKMARK 2129
#define MEID_EDIT_TOGGLE_SPELL 2130
#define MEID_EDIT_NEXT_SPELL 2131
#define MEID_EDIT_PREV_SPELL 2132
#define MEID_SEARCH_FIND 2133
#define MEID_SEARCH_NEXT 2134
#define MEID_SEARCH_PREV 2135
#define MEID_SEARCH_NEXT_WORD 2136
#define MEID_SEARCH_PREV_WORD 2137
#define MEID_SEARCH_REPLACE 2138
#define MEID_SEARCH_ERASE_FIND_HIGHLIGHT 2139
#define MEID_SEARCH_FIND_IN_FILES 2140
#define MEID_SEARCH_REPLACE_IN_FILES 2141
#define MEID_SEARCH_GOOGLE 2142
#define MEID_SEARCH_WIKIPEDIA 2143
#define MEID_VIEW_MODE_CUSTOMIZE 2144
#define MEID_VIEW_INVERT_COLOR 2145
#define MEID_VIEW_WRAP_NONE 2146
#define MEID_VIEW_WRAP_BY_CHAR 2147
#define MEID_VIEW_WRAP_BY_WINDOW 2148
#define MEID_VIEW_SHOW_LINE_NUMBERS 2149
#define MEID_VIEW_SHOW_RULER 2150
#define MEID_VIEW_SHOW_CRLF 2151
#define MEID_VIEW_SHOW_WRAP 2152
#define MEID_VIEW_SHOW_EOF 2153
#define MEID_VIEW_SHOW_TABS 2154
#define MEID_VIEW_SHOW_SB_SPACES 2155
#define MEID_VIEW_SHOW_DB_SPACES 2156
#define MEID_VIEW_CRLF_DIFFERENT 2157
#define MEID_VIEW_STANDARD_BAR 2158
#define MEID_VIEW_MACROS_BAR 2159
#define MEID_VIEW_PLUGINS_BAR 2160
#define MEID_VIEW_TOOLS_BAR 2161
#define MEID_VIEW_TOOL_BAR_TITLES 2162
#define MEID_VIEW_LOCK_TOOL_BARS 2163
#define MEID_VIEW_TOOL_BAR_CUSTOMIZE 2164
#define MEID_VIEW_STATUS_BAR 2165
#define MEID_VIEW_OUTPUT_BAR 2166
#define MEID_VIEW_INC_FONT_SIZE 2167
#define MEID_VIEW_DEC_FONT_SIZE 2168
#define MEID_VIEW_FONT_CUSTOMIZE 2169
#define MEID_MACROS_RECORD 2170
#define MEID_MACROS_RUN 2171
#define MEID_MACROS_SAVE 2172
#define MEID_MACROS_EDIT 2173
#define MEID_MACROS_SELECT 2174
#define MEID_MACROS_SELECT_THIS 2175
#define MEID_MACROS_CUSTOMIZE 2176
#define MEID_TOOLS_OPTIONS 2177
#define MEID_TOOLS_COMPLETION 2178
#define MEID_TOOLS_SQL_FORMAT 2179
#define MEID_TOOLS_XML_FORMAT 2180
#define MEID_TOOLS_PLUGIN_CUSTOMIZE 2181
#define MEID_TOOLS_TOOL_CUSTOMIZE 2182
#define MEID_TOOLS_TERMINATE_TOOL 2183
#define MEID_TOOLS_POPUP_MENU_CUSTOMIZE 2184
#define MEID_WINDOW_ALWAYS_TOP 2185
#define MEID_WINDOW_SPLIT 2186
#define MEID_WINDOW_NEXT_PANE 2187
#define MEID_WINDOW_PREV_PANE 2188
#define MEID_WINDOW_ACTIVE_PANE 2189
#define MEID_WINDOW_COMBINE 2190
#define MEID_WINDOW_CASCADE 2191
#define MEID_WINDOW_TILE_HORZ 2192
#define MEID_WINDOW_TILE_VERT 2193
#define MEID_WINDOW_MINIMIZE_ALL 2194
#define MEID_WINDOW_NEXT 2195
#define MEID_WINDOW_PREV 2196
#define MEID_HELP_ONLINE 2197
#define MEID_HELP_KEYBOARD_MAP 2198
#define MEID_HELP_ABOUT 2199
// 2.2.5
#define MEID_EDIT_PASTE_QUOTES 2200
#define MEID_EDIT_COPY_LINK 2201
#define MEID_EDIT_OPEN_LINK 2202

#define MEID_MY_DICTS 4096
#define MEID_MY_MODES 5120
#define MEID_MY_MACROS 6144
#define MEID_MY_PLUGINS 7168
#define MEID_MY_TOOLS 8192

typedef struct _GET_LINE_INFO
{
	UINT_PTR cch;
	UINT flags;
	UINT_PTR yLine;
} GET_LINE_INFO;

typedef struct _MATCH_REGEX_INFO
{
	size_t cbSize;
	UINT nFlags;
	LPCWSTR pszRegex;
	LPCWSTR pszText;
	LPCWSTR pszReplace;
	LPWSTR pszResult;
	UINT cchResult;
} MATCH_REGEX_INFO;

typedef struct _FIND_REGEX_INFO
{
	size_t cbSize;
	UINT nFlags;
	LPCWSTR pszRegex;
	LPCWSTR pszText;
	LPCWSTR* ppszStart;
	LPCWSTR* ppszEnd;
	LPCWSTR* ppszNext;
} FIND_REGEX_INFO;

typedef struct _CUSTOM_BAR_INFO
{
	size_t cbSize;
	HWND hwndCustomBar;
	HWND hwndClient;
	LPCTSTR pszTitle;
	int iPos;
} CUSTOM_BAR_INFO;

typedef struct _CUSTOM_BAR_CLOSE_INFO
{
	UINT nID;
	int iPos;
	DWORD dwFlags;
} CUSTOM_BAR_CLOSE_INFO;

typedef struct tagPOINT_PTR
{
	LONG x;
	LONG y;
} POINT_PTR, *PPOINT_PTR;

typedef struct tagSIZE_PTR
{
	LONG cx;
	LONG cy;
} SIZE_PTR, *PSIZE_PTR;

typedef struct _TOOLBAR_INFO
{
	size_t cbSize;
	HWND hwndToolBar;
	HWND hwndClient;
	LPCTSTR pszTitle;
	UINT nID;
	UINT nFlags;
	BOOL bVisible;
} TOOLBAR_INFO;

// -----------------------------------------------------------------------------
// Editor_New
//   VKɃt@C쐬܂
// p[^
//   hwnd:      EBhẼnh
// ߂l
//   EBhẼnh

inline UINT Editor_New(HWND hwnd)
{
	return (UINT)SendMessage(hwnd, ME_NEW, (WPARAM)0, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetCmdID
//   vOC̃R}hID擾܂
// p[^
//   hwnd:      EBhẼnh
//   hInstance: vOC̃CX^X̃nh
// ߂l
//   vOCs邽߂̃R}hID

inline UINT Editor_GetCmdID(HWND hwnd, HINSTANCE hInstance)
{
	return (UINT)SendMessage(hwnd, ME_GET_CMD_ID, 0, (LPARAM)hInstance);
}

// -----------------------------------------------------------------------------
// Editor_QueryStatus
//   vOCs\A܂̓`FbNꂽԂ𒲂ׂ܂
// p[^
//   hwnd:      EBhẼnh
//   nCmdID:    svOC̃R}hID
//   pbChecked: `FbN̏
// ߂l
//   s\łTrueԂ܂

inline BOOL Editor_QueryStatus(HWND hwnd, UINT nCmdID, BOOL* pbChecked)
{
	return (BOOL)SendMessage(hwnd, ME_QUERY_STATUS, (WPARAM)nCmdID, (LPARAM)pbChecked);
}

// -----------------------------------------------------------------------------
// Editor_GetSelText
//   IĂ镶擾܂
// p[^
//   hwnd:        EBhẼnh
//   nBufferSize: I[܂ރobt@̃TCY
//   szBuffer:    擾obt@ւ̃|C^
// ߂l
//   nBufferSize0̏ꍇ̓obt@ɕKvȃTCYA0ȊȌꍇ͎gp܂

inline UINT_PTR Editor_GetSelText(HWND hwnd, UINT_PTR nBufferSize, LPWSTR szBuffer)
{
	return (UINT_PTR)SendMessage(hwnd, ME_GET_SEL_TEXT, (WPARAM)nBufferSize, (LPARAM)szBuffer);
}

// -----------------------------------------------------------------------------
// Editor_GetLines
//   ̍s擾܂
// p[^
//   hwnd:     EBhẼnh
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
// ߂l
//   ̍sԂ܂

inline UINT_PTR Editor_GetLines(HWND hwnd, int nLogical)
{
	return (UINT_PTR)SendMessage(hwnd, ME_GET_LINES, (WPARAM)(int)(nLogical), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetDocLines
//   w肷镶̍s擾܂
// p[^
//   hwnd:     EBhẼnh
//   iDoc:     ΏۂƂȂ镶0ƂCfbNX
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
// ߂l
//   ̍sԂ܂

inline UINT_PTR Editor_GetDocLines(HWND hwnd, int iDoc, int nLogical)
{
	return (UINT_PTR)SendMessage(hwnd, ME_GET_LINES, MAKEWPARAM(nLogical, iDoc + 1), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetLine
//   w肵s̕擾܂
// p[^
//   hwnd:         EBhẼnh
//   pGetLineInfo: GET_LINE_INFO\̂ւ̃|C^
//   szString:     擾obt@ւ̃|C^
// ߂l
//   pGetLineInfo->cch0̏ꍇ̓obt@ɕKvȃTCYA0ȊȌꍇ͎gp܂

inline UINT_PTR Editor_GetLine(HWND hwnd, GET_LINE_INFO* pGetLineInfo, LPWSTR szString)
{
	return (UINT_PTR)SendMessage(hwnd, ME_GET_LINE, (WPARAM)(GET_LINE_INFO*)(pGetLineInfo), (LPARAM)(LPWSTR)(szString));
}

// -----------------------------------------------------------------------------
// Editor_GetCaretPos
//   J[\ʒu擾܂
// p[^
//   hwnd:     EBhẼnh
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
//   pptPos:   J[\̈ʒui[邽߂̍\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_GetCaretPos(HWND hwnd, int nLogical, POINT_PTR* pptPos)
{
	SendMessage(hwnd, ME_GET_CARET_POS, (WPARAM)nLogical, (LPARAM)pptPos);
}

// -----------------------------------------------------------------------------
// Editor_GetScrollPos
//   XN[o[̈ʒu擾܂
// p[^
//   hwnd:     EBhẼnh
//   pptPos:   XN[o[̈ʒui[邽߂̍\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_GetScrollPos(HWND hwnd, POINT_PTR* pptPos)
{
	SendMessage(hwnd, ME_GET_SCROLL_POS, (WPARAM)0, (LPARAM)(POINT_PTR*)(pptPos));
}

// -----------------------------------------------------------------------------
// Editor_LineFromChar
//   w肵VAʒu̍sԍԂ܂
// p[^
//   hwnd:         EBhẼnh
//   nLogical:     POS_VIEW(\W)܂POS_LOGICAL(_W)
//   nSerialIndex: VAʒu(-1w肵ꍇ̓J[\ʒu)
// ߂l
//   sԍԂ܂

inline UINT_PTR Editor_LineFromChar(HWND hwnd, int nLogical, UINT_PTR nSerialIndex)
{
	return (UINT_PTR)SendMessage(hwnd, ME_LINE_FROM_CHAR, (WPARAM)(int)(nLogical), (LPARAM)(UINT_PTR)(nSerialIndex));
}

// -----------------------------------------------------------------------------
// Editor_LineIndex
//   w肵sԍ̃VAʒuԂ܂
// p[^
//   hwnd:     EBhẼnh
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
//   yLine:    sԍ(-1w肵ꍇ̓J[\s)
// ߂l
//   VAʒuԂ܂

inline UINT_PTR Editor_LineIndex(HWND hwnd, BOOL bLogical, UINT_PTR yLine)
{
	return (UINT_PTR)SendMessage(hwnd, ME_LINE_INDEX, (WPARAM)(BOOL)(bLogical), (LPARAM)(UINT_PTR)(yLine));
}

// -----------------------------------------------------------------------------
// Editor_LoadFile
//   t@CJ܂
// p[^
//   hwnd:            EBhẼnh
//   bAllowNewWindow: VEBhEŊJ܂
//   szFileName:      ǂݍރt@C
// ߂l
//   TrueԂ܂

inline BOOL Editor_LoadFile(HWND hwnd, LPCWSTR szFileName)
{
	return (BOOL)SendMessage(hwnd, ME_LOAD_FILE, (WPARAM)0, (LPARAM)(LPCWSTR)(szFileName));
}

// -----------------------------------------------------------------------------
// Editor_LogicalToSerial
//   _WVAʒuɕϊ܂
// p[^
//   hwnd:       EBhẼnh
//   pptLogical: _Ww肵\̂ւ̃|C^
// ߂l
//   VAʒuԂ܂

inline UINT_PTR Editor_LogicalToSerial(HWND hwnd, POINT_PTR* pptLogical)
{
	return (UINT_PTR)SendMessage(hwnd, ME_LOGICAL_TO_SERIAL, (WPARAM)0, (LPARAM)(POINT_PTR*)(pptLogical));
}

// -----------------------------------------------------------------------------
// Editor_LogicalToView
//   _W\Wɕϊ܂
// p[^
//   hwnd:       EBhẼnh
//   pptLogical: _Ww肵\̂ւ̃|C^
//   pptView:    \Ww肵\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_LogicalToView(HWND hwnd, POINT_PTR* pptLogical, POINT_PTR* pptView)
{
	SendMessage(hwnd, ME_LOGICAL_TO_VIEW, (WPARAM)(POINT_PTR*)(pptLogical), (LPARAM)(POINT_PTR*)(pptView));
}

// -----------------------------------------------------------------------------
// Editor_SaveFile
//   t@Cɕۑ܂
// p[^
//   hwnd:       EBhẼnh
//   szFileName: ۑt@C
// ߂l
//   TrueԂ܂

inline BOOL Editor_SaveFile(HWND hwnd, LPWSTR szFileName)
{
	return (BOOL)SendMessage(hwnd, ME_SAVE_FILE, 0, (LPARAM)(LPWSTR)(szFileName));
}

// -----------------------------------------------------------------------------
// Editor_DocSaveFile
//   w肷镶t@Cɕۑ܂
// p[^
//   hwnd:       EBhẼnh
//   iDoc:       ΏۂƂȂ镶0ƂCfbNX
//   szFileName: ۑt@C
// ߂l
//   TrueԂ܂

inline BOOL Editor_DocSaveFile(HWND hwnd, int iDoc, LPWSTR szFileName)
{
	return (BOOL)SendMessage(hwnd, ME_SAVE_FILE, MAKEWPARAM(0, iDoc + 1), (LPARAM)(LPWSTR)(szFileName));
}

// -----------------------------------------------------------------------------
// Editor_SerialToLogical
//   VAʒu_Wɕϊ܂
// p[^
//   hwnd:       EBhẼnh
//   nSerial:    VAʒu
//   pptLogical: _Wi[邽߂̍\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_SerialToLogical(HWND hwnd, UINT_PTR nSerial, POINT_PTR* pptLogical)
{
	SendMessage(hwnd, ME_SERIAL_TO_LOGICAL, (WPARAM)(UINT_PTR)(nSerial), (LPARAM)(POINT_PTR*)(pptLogical));
}

// -----------------------------------------------------------------------------
// Editor_SetCaretPos
//   J[\ʒuݒ肵܂
// p[^
//   hwnd:     EBhẼnh
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
//   pptPos:   J[\ʒuw肵\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_SetCaretPos(HWND hwnd, int nLogical, POINT_PTR* pptPos)
{
	SendMessage(hwnd, ME_SET_CARET_POS, (WPARAM)(int)(nLogical), (LPARAM)(POINT_PTR*)(pptPos));
}

// -----------------------------------------------------------------------------
// Editor_SetCaretPosEx
//   J[\ʒuݒ肵܂
// p[^
//   hwnd:      EBhẼnh
//   nLogical:  POS_VIEW(\W)܂POS_LOGICAL(_W)
//   pptPos:    J[\ʒuw肵\̂ւ̃|C^
//   bExtend:   I͈͂Lk邩ǂ
// ߂l
//   gp܂

inline void Editor_SetCaretPosEx(HWND hwnd, int nLogical, POINT_PTR* pptPos, BOOL bExtend)
{
	SendMessage(hwnd, ME_SET_CARET_POS, MAKEWPARAM(nLogical, bExtend), (LPARAM)(POINT_PTR*)(pptPos));
}

// -----------------------------------------------------------------------------
// Editor_SetScrollPos
//   XN[o[̈ʒuݒ肵܂
// p[^
//   hwnd:   EBhẼnh
//   pptPos: XN[o[̈ʒuw肵\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_SetScrollPos(HWND hwnd, POINT_PTR* pptPos)
{
	SendMessage(hwnd, ME_SET_SCROLL_POS, (WPARAM)0, (LPARAM)(POINT_PTR*)(pptPos));
}

// -----------------------------------------------------------------------------
// Editor_ViewToLogical
//   \W_Wɕϊ܂
// p[^
//   hwnd:   EBhẼnh
//   pptView:    \Ww肵\̂ւ̃|C^
//   pptLogical: _Ww肵\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_ViewToLogical(HWND hwnd, POINT_PTR* pptView, POINT_PTR* pptLogical)
{
	SendMessage(hwnd, ME_VIEW_TO_LOGICAL, (WPARAM)(POINT_PTR*)(pptView), (LPARAM)(POINT_PTR*)(pptLogical));
}

// -----------------------------------------------------------------------------
// Editor_ExecCommand
//   w肷R}hIDs܂
// p[^
//   hwnd:    EBhẼnh
//   pptView: sR}hID
// ߂l
//   gp܂

inline void Editor_ExecCommand(HWND hwnd, UINT nCmdID)
{
	SendMessage(hwnd, ME_EXEC_COMMAND, (WPARAM)(UINT)(nCmdID), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetModified
//   XVĂ邩ǂ擾܂
// p[^
//   hwnd: EBhẼnh
// ߂l
//   XVĂꍇTrueԂ܂

inline BOOL Editor_GetModified(HWND hwnd)
{
	return (BOOL)SendMessage(hwnd, ME_GET_MODIFIED, (WPARAM)0, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_DocGetModified
//   w肷镶XVĂ邩ǂ擾܂
// p[^
//   hwnd: EBhẼnh
//   iDoc: ΏۂƂȂ镶0ƂCfbNX
// ߂l
//   XVĂꍇTrueԂ܂

inline BOOL Editor_GetModified(HWND hwnd, int iDoc)
{
	return (BOOL)SendMessage(hwnd, ME_GET_MODIFIED, MAKEWPARAM(0, iDoc + 1), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_SetModified
//   XVĂ邩ǂݒ肵܂
// p[^
//   hwnd:      EBhẼnh
//   bModified: XV̏
// ߂l
//   gp܂

inline void Editor_SetModified(HWND hwnd, BOOL bModified)
{
	(void)SendMessage(hwnd, ME_SET_MODIFIED, (WPARAM)(BOOL)(bModified), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetSelStart
//   I𕶎̊Jnʒu擾܂
// p[^
//   hwnd:     EBhẼnh
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
//   pptPos:   I𕶎̊Jnʒui[邽߂̍\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_GetSelStart(HWND hwnd, int nLogical, POINT_PTR* pptPos)
{
	SendMessage(hwnd, ME_GET_SEL_START, (WPARAM)(int)(nLogical), (LPARAM)(POINT_PTR*)(pptPos));
}

// -----------------------------------------------------------------------------
// Editor_GetSelEnd
//   I𕶎̏Iʒu擾܂
// p[^
//   hwnd:     EBhẼnh
//   nLogical: POS_VIEW(\W)܂POS_LOGICAL(_W)
//   pptPos:   I𕶎̏Iʒui[邽߂̍\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_GetSelEnd(HWND hwnd, int nLogical, POINT_PTR* pptPos)
{
	SendMessage(hwnd, ME_GET_SEL_END, (WPARAM)(int)(nLogical), (LPARAM)(POINT_PTR*)(pptPos));
}

// -----------------------------------------------------------------------------
// Editor_SetSelLength
//   I𕶎̒ݒ肵܂
// p[^
//   hwnd: EBhẼnh
//   nLen: I𕶎̒
// ߂l
//   gp܂

inline void Editor_SetSelLength(HWND hwnd, UINT_PTR nLen)
{
	(void)SendMessage(hwnd, ME_SET_SEL_LENGTH, (WPARAM)(UINT_PTR)(nLen), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetMode
//   ҏW[h𕶎Ŏ擾܂
// p[^
//   hwnd:         EBhẼnh
//   szModeName: ̂擾obt@(MAX_MODE_NAME̕)
// ߂l
//   gp܂

inline void Editor_GetMode(HWND hwnd, LPWSTR szModeName)
{
	SendMessage(hwnd, ME_GET_MODE, (WPARAM)0, (LPARAM)(LPWSTR)(szModeName));
}

// -----------------------------------------------------------------------------
// Editor_DocGetMode
//   w肷镶̕ҏW[h𕶎Ŏ擾܂
// p[^
//   hwnd:       EBhẼnh
//   iDoc:       ΏۂƂȂ镶0ƂCfbNX
//   szModeName: ̂擾obt@(MAX_MODE_NAME̕)
// ߂l
//   gp܂

inline void Editor_DocGetMode(HWND hwnd, int iDoc, LPWSTR szModeName)
{
	SendMessage(hwnd, ME_GET_MODE, MAKEWPARAM(0, iDoc + 1), (LPARAM)(LPWSTR)(szModeName));
}

// -----------------------------------------------------------------------------
// Editor_SetMode
//   ҏW[h𕶎Őݒ肵܂
// p[^
//   hwnd:         EBhẼnh
//   szModeName: ҏW[h̖
// ߂l
//   gp܂

inline BOOL Editor_SetMode(HWND hwnd, LPWSTR szModeName)
{
	return (BOOL)SendMessage(hwnd, ME_SET_MODE, (WPARAM)0, (LPARAM)(LPWSTR)(szModeName));
}

// -----------------------------------------------------------------------------
// Editor_DocSetMode
//   w肷镶̕ҏW[h𕶎Őݒ肵܂
// p[^
//   hwnd:       EBhẼnh
//   iDoc:       ΏۂƂȂ镶0ƂCfbNX
//   szModeName: ҏW[h̖
// ߂l
//   gp܂

inline BOOL Editor_DocSetMode(HWND hwnd, int iDoc, LPWSTR szModeName)
{
	return (BOOL)SendMessage(hwnd, ME_SET_MODE, MAKEWPARAM(0, iDoc + 1), (LPARAM)(LPWSTR)(szModeName));
}

// -----------------------------------------------------------------------------
// Editor_EmptyUndoBuffer
//   ɖ߂A蒼̃obt@ɂ܂
// p[^
//   hwnd: EBhẼnh
// ߂l
//   gp܂

inline void Editor_EmptyUndoBuffer(HWND hwnd)
{
	SendMessage(hwnd, ME_EMPTY_UNDO_BUFFER, (WPARAM)0, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_InsertString
//   J[\ʒuɕ}܂͏㏑܂
// p[^
//   hwnd:     EBhẼnh
//   szString: }镶
// ߂l
//   gp܂

inline void Editor_InsertString(HWND hwnd, LPCWSTR szString)
{
	SendMessage(hwnd, ME_INSERT_STRING, (WPARAM)OVERWRITE_PER_PROP, (LPARAM)(LPCWSTR)(szString));
}

// -----------------------------------------------------------------------------
// Editor_Insert
//   J[\ʒuɕ}܂
// p[^
//   hwnd:     EBhẼnh
//   szString: }镶
// ߂l
//   gp܂

inline void Editor_Insert(HWND hwnd, LPCWSTR szString)
{
	SendMessage(hwnd, ME_INSERT_STRING, (WPARAM)OVERWRITE_INSERT, (LPARAM)(LPCWSTR)(szString));
}

// -----------------------------------------------------------------------------
// Editor_Overwrite
//   J[\ʒuɕ㏑܂
// p[^
//   hwnd:     EBhẼnh
//   szString: }镶
// ߂l
//   gp܂

inline void Editor_Overwrite(HWND hwnd, LPCWSTR szString)
{
	SendMessage(hwnd, ME_INSERT_STRING, (WPARAM)OVERWRITE_OVERWRITE, (LPARAM)(LPCWSTR)(szString));
}

// -----------------------------------------------------------------------------
// Editor_SetSelView
//   I𕶎̊JnʒuƏIʒuݒ肵܂
// p[^
//   hwnd:        EBhẼnh
//   pptSelStart: I𕶎̊Jnʒu\\̂ւ̃|C^
//   pptSelEnd:   I𕶎̏Iʒu\\̂ւ̃|C^
// ߂l
//   gp܂

inline void Editor_SetSelView(HWND hwnd, POINT_PTR* pptSelStart, POINT_PTR* pptSelEnd)
{
	SendMessage(hwnd, ME_SET_SEL_VIEW, (WPARAM)(POINT_PTR*)(pptSelStart), (LPARAM)(POINT_PTR*)(pptSelEnd));
}

// -----------------------------------------------------------------------------
// Editor_Find
//   ܂
// p[^
//   hwnd:   EBhẼnh
//   nFlags: tO
//   szFind: 镶
// ߂l
//   TrueԂ܂
// l
//   FLAG_FIND_NEXT:      Ɍ܂
//   FLAG_FIND_CASE:      啶Əʂ܂
//   FLAG_FIND_ONLY_WORD: P̂݌܂
//   FLAG_FIND_AROUND:    ܂Ō當Ɉړ܂
//   FLAG_FIND_REG_EXP:   K\gp܂

inline BOOL Editor_Find(HWND hwnd, UINT nFlags, LPCWSTR szFind)
{
	return (BOOL)SendMessage(hwnd, ME_FIND, (WPARAM)(UINT)(nFlags), (LPARAM)(LPCWSTR)(szFind));
}

// -----------------------------------------------------------------------------
// Editor_Replace
//   u܂
// p[^
//   hwnd:   EBhẼnh
//   nFlags: tO
//   szFind: 镶ƒu镶(؂AI[#0w)
// ߂l
//   TrueԂ܂
// l
//   FLAG_FIND_CASE:        啶Əʂ܂
//   FLAG_FIND_ONLY_WORD:   P̂݌܂
//   FLAG_FIND_REG_EXP:     K\gp܂
//   FLAG_REPLACE_SEL_ONLY: I͈݂͂̂ΏۂƂ܂

inline BOOL Editor_Replace(HWND hwnd, UINT nFlags, LPCWSTR szFindReplace)
{
	return (BOOL)SendMessage(hwnd, ME_REPLACE, (WPARAM)(UINT)(nFlags), (LPARAM)(LPCWSTR)(szFindReplace));
}

// -----------------------------------------------------------------------------
// Editor_SetStatus
//   Xe[^Xo[ɕ\镶ݒ肵܂
// p[^
//   hwnd:     EBhẼnh
//   szStatus: Xe[^Xo[ɕ\镶
// ߂l
//   gp܂

inline void Editor_SetStatus(HWND hwnd, LPCWSTR szStatus)
{
	SendMessage(hwnd, ME_SET_STATUS, (WPARAM)0, (LPARAM)(LPCWSTR)(szStatus));
}

// -----------------------------------------------------------------------------
// Editor_Convert
//   ϊ܂
// p[^
//   hwnd:   EBhẼnh
//   nFlags: tO
// ߂l
//   TrueԂ܂
// l
//   FLAG_MAKE_LOWER:         ɕϊ܂
//   FLAG_MAKE_UPPER:         啶ɕϊ܂
//   FLAG_HAN_TO_ZEN:         Spɕϊ܂
//   FLAG_ZEN_TO_HAN:         pɕϊ܂
//   FLAG_CONVERT_SELECT_ALL: ŜΏۂƂ܂

inline BOOL Editor_Convert(HWND hwnd, UINT nFlags)
{
	return (BOOL)SendMessage(hwnd, ME_CONVERT, (WPARAM)(UINT)(nFlags), (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetMargin
//   ܂ԂԂ܂
// p[^
//   hwnd: EBhẼnh
// ߂l
//   ܂ԂԂ܂

inline UINT_PTR Editor_GetMargin(HWND hwnd)
{
	return (UINT_PTR)SendMessage(hwnd, ME_GET_MARGIN, (WPARAM)0, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetVersion
//   o[WԍԂ܂
// p[^
//   hwnd: EBhẼnh
// ߂l
//   o[WԍԂ܂

inline UINT Editor_GetVersion(HWND hwnd)
{
	return (UINT)SendMessage(hwnd, ME_GET_VERSION, (WPARAM)0, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetVersionEx
//   Ă܂

inline UINT Editor_GetVersionEx(HWND hwnd, UINT* pnProductType)
{
	return (UINT)SendMessage(hwnd, ME_GET_VERSION, (WPARAM)pnProductType, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_Redraw
//   EBhE̍ĕ`sǂw肵܂
// p[^
//   hwnd:    EBhẼnh
//   bRedraw: Falsew肷ƁATruew肷܂ōĕ`s܂
// ߂l
//   gp܂

inline void Editor_Redraw(HWND hwnd, BOOL bRedraw)
{
	SendMessage(hwnd, ME_REDRAW, (WPARAM)bRedraw, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_GetSelType
//   IԂ̎ނ擾܂
// p[^
//   hwnd: EBhẼnh
// ߂l
//   SEL_TYPE_NONE: IĂ܂
//   SEL_TYPE_CHAR: ʏIĂ܂
//   SEL_TYPE_BOX:  `IĂ܂

inline int Editor_GetSelType(HWND hwnd)
{
	return (int)SendMessage(hwnd, ME_GET_SEL_TYPE, (WPARAM)0, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_IsCharHalfOrFull
//   w肷镶pSp𒲂ׂ܂
// p[^
//   hwnd: EBhẼnh
//   ch:   ׂ
// ߂l
//   p̏ꍇ1ASp̏ꍇ2Ԃ܂

inline int Editor_IsCharHalfOrFull(HWND hwnd, WCHAR ch)
{
	return (int)SendMessage(hwnd, ME_IS_CHAR_HALF_OR_FULL, (WPARAM)ch, (LPARAM)0);
}

// -----------------------------------------------------------------------------
// Editor_Info
//   ̏擾Eݒ肵܂
// p[^
//   hwnd: EBhẼnh
//   nCmd: 擾Eݒ肷̎
// ߂l
//   nCmdɂقȂ܂
// l
//   MI_GET_FILE_NAME:      JĂt@C擾܂
//   MI_GET_APP_VERSION:    o[W擾܂
//   MI_IS_WINDOW_COMBINED: ^u̗LE擾܂
//   MI_WINDOW_COMBINE:     ^u̗LEݒ肵܂
//   MI_GET_DOC_COUNT:      JĂ镶̐擾܂
//   MI_INDEX_TO_DOC:       ̃CfbNXnhɕϊ܂
//   MI_DOC_TO_INDEX:       ̃nhCfbNXɕϊ܂
//   MI_GET_ACTIVE_INDEX:   ANeBuȕ̃CfbNX擾܂
//   MI_SET_ACTIVE_INDEX:   CfbNXw肵ĕANeBuɂ܂
//   MI_GET_ACTIVE_DOC:     ANeBuȕ̃nh擾܂
//   MI_SET_ACTIVE_DOC:     nhw肵ĕANeBuɂ܂
//   MI_CLOSE_DOC:          ܂
//   MI_SAVE_DOC:           ۑ܂
//   MI_GET_FONT_NAME:      tHg擾܂
//   MI_GET_FONT_CHARSET:   tHg̕Zbg擾܂
//   MI_GET_FONT_SIZE:      tHg̃TCY擾܂
//   MI_GET_TEXT_COLOR:     ̐F擾܂
//   MI_GET_BACK_COLOR:     wi̐F擾܂

inline LRESULT Editor_Info(HWND hwnd, WPARAM nCmd, LPARAM lParam)
{
	return (LRESULT)SendMessage(hwnd, ME_INFO, (WPARAM)nCmd, (LPARAM)lParam);
}

// -----------------------------------------------------------------------------
// Editor_DocInfo
//   w肷镶̏擾Eݒ肵܂
// p[^
//   hwnd: EBhẼnh
//   iDoc: 0Ƃ镶̃CfbNX
//   nCmd: 擾Eݒ肷̎
// ߂l
//   nCmdɂقȂ܂
// l
//   MI_GET_FILE_NAME:      JĂt@C擾܂
//   MI_GET_APP_VERSION:    o[W擾܂
//   MI_IS_WINDOW_COMBINED: ^u̗LE擾܂
//   MI_WINDOW_COMBINE:     ^u̗LEݒ肵܂
//   MI_GET_DOC_COUNT:      JĂ镶̐擾܂
//   MI_INDEX_TO_DOC:       ̃CfbNXnhɕϊ܂
//   MI_DOC_TO_INDEX:       ̃nhCfbNXɕϊ܂
//   MI_GET_ACTIVE_INDEX:   ANeBuȕ̃CfbNX擾܂
//   MI_SET_ACTIVE_INDEX:   CfbNXw肵ĕANeBuɂ܂
//   MI_GET_ACTIVE_DOC:     ANeBuȕ̃nh擾܂
//   MI_SET_ACTIVE_DOC:     nhw肵ĕANeBuɂ܂
//   MI_CLOSE_DOC:          ܂
//   MI_SAVE_DOC:           ۑ܂
//   MI_GET_FONT_NAME:      tHg擾܂
//   MI_GET_FONT_CHARSET:   tHg̕Zbg擾܂
//   MI_GET_FONT_SIZE:      tHg̃TCY擾܂
//   MI_GET_TEXT_COLOR:     ̐F擾܂
//   MI_GET_BACK_COLOR:     wi̐F擾܂

inline LRESULT Editor_DocInfo(HWND hwnd, int iDoc, WPARAM nCmd, LPARAM lParam)
{
	return (LRESULT)SendMessage(hwnd, ME_INFO, MAKEWPARAM(nCmd, iDoc + 1), (LPARAM)lParam);
}

// -----------------------------------------------------------------------------
// Editor_GetStatus
//   Xe[^Xo[ɕ\Ă镶擾܂
// p[^
//   hwnd:        EBhẼnh
//   szStatus:    擾obt@
//   nBufferSize: 擾obt@̃TCY
// ߂l
//   擾̂ɕKvȃobt@̃TCY

inline UINT_PTR Editor_GetStatus(HWND hwnd, LPCWSTR szStatus, UINT_PTR nBufSize)
{
	return (UINT_PTR)SendMessage(hwnd, ME_GET_STATUS, (WPARAM)nBufSize, (LPARAM)(LPCWSTR)(szStatus));
}

// -----------------------------------------------------------------------------
// Editor_CustomBarOpen
//   JX^o[J܂
// p[^
//   hwnd:           EBhẼnh
//   pCustomBarInfo: CUSTOM_BAR_INFO\̂ւ̃|C^
// ߂l
//   ƃJX^o[IDԂ܂

inline UINT Editor_CustomBarOpen(HWND hwnd, CUSTOM_BAR_INFO* pCustomBarInfo)
{
	return (UINT)SendMessage(hwnd, ME_CUSTOM_BAR_OPEN, 0, (LPARAM)pCustomBarInfo);
}

// -----------------------------------------------------------------------------
// Editor_CustomBarClose
//   JX^o[܂
// p[^
//   hwnd:         EBhẼnh
//   nCustomBarID: JX^o[ID
// ߂l
//   gp܂

inline BOOL Editor_CustomBarClose(HWND hwnd, UINT nCustomBarID)
{
	return (BOOL)SendMessage(hwnd, ME_CUSTOM_BAR_CLOSE, (WPARAM)nCustomBarID, 0);
}

// -----------------------------------------------------------------------------
// Editor_MatchRegEx
//   K\Ŏw肵񂪈v邩ǂ𒲂ׂ܂
// p[^
//   hwnd:            EBhẼnh
//   pMatchRegExInfo: MATCH_REGEX_INFO\̂ւ̃|C^
// ߂l
//   w肷镶񂪈vꍇTrueԂ܂

inline BOOL Editor_MatchRegex(HWND hwnd, MATCH_REGEX_INFO* pMatchRegexInfo)
{
	return (BOOL)SendMessage(hwnd, ME_MATCH_REGEX, (WPARAM)0, (LPARAM)pMatchRegexInfo);
}

// -----------------------------------------------------------------------------
// Editor_FindRegEx
//   K\w肵񂩂猟܂
// p[^
//   hwnd:            EBhẼnh
//   pMatchRegExInfo: FIND_REGEX_INFO\̂ւ̃|C^
// ߂l
//   w肷镶񂪈v镶񂪌ꍇTrueԂ܂

inline BOOL Editor_FindRegex(HWND hwnd, FIND_REGEX_INFO* pFindRegexInfo)
{
	return (BOOL)SendMessage(hwnd, ME_FIND_REGEX, (WPARAM)0, (LPARAM)pFindRegexInfo);
}

// -----------------------------------------------------------------------------
// Editor_EnumMode
//   ҏW[ḧꗗ擾܂
// p[^
//   hwnd:   EBhẼnh
//   pBuf:   擾obt@ւ̃|C^
//   cchBuf: I[܂ރobt@̃TCY
// ߂l
//   cchBuf0̏ꍇ̓obt@ɕKvȃTCYA0ȊȌꍇ͎gp܂

inline size_t Editor_EnumConfig(HWND hwnd, LPWSTR pBuf, size_t cchBuf)
{
	return (size_t)SendMessage(hwnd, ME_ENUM_MODE, (WPARAM)cchBuf, (LPARAM)pBuf);
}

// -----------------------------------------------------------------------------
// Editor_ToolBarOpen
//   c[o[J܂
// p[^
//   hwnd:         EBhẼnh
//   pToolBarInfo: TOOL_BAR_INFO\̂ւ̃|C^
// ߂l
//   ƃc[o[IDԂ܂

inline UINT Editor_ToolBarOpen(HWND hwnd, TOOLBAR_INFO* pToolBarInfo)
{
	return (UINT)SendMessage(hwnd, ME_TOOL_BAR_OPEN, 0, (LPARAM)pToolBarInfo);
}

// -----------------------------------------------------------------------------
// Editor_ToolBarClose
//   c[o[܂
// p[^
//   hwnd:       EBhẼnh
//   nToolBarID: c[o[ID
// ߂l
//   gp܂

inline BOOL Editor_ToolBarClose(HWND hwnd, UINT nToolBarID)
{
	return (BOOL)SendMessage(hwnd, ME_TOOL_BAR_CLOSE, (WPARAM)nToolBarID, 0);
}

// -----------------------------------------------------------------------------
// Editor_ToolBarShow
//   c[o[̕\/\؂ւ܂
// p[^
//   hwnd:       EBhẼnh
//   nToolBarID: c[o[ID
//   bVisible:   \̏
// ߂l
//   gp܂

inline BOOL Editor_ToolBarShow(HWND hwnd, UINT nToolBarID, BOOL bVisible)
{
	return (BOOL)SendMessage(hwnd, ME_TOOL_BAR_SHOW, (WPARAM)nToolBarID, (LPARAM)bVisible);
}

// -----------------------------------------------------------------------------
// Editor_OutputString
//   AEgvbgo[ɕǉ܂
// p[^
//   hwnd:     EBhẼnh
//   szString: ǉ镶
//   nFlags:   tO
// ߂l
//   TrueԂ܂
// l
//   FLAG_OPEN_OUTPUT:  AEgvbgo[J܂
//   FLAG_CLOSE_OUTPUT: AEgvbgo[܂
//   FLAG_FOCUS_OUTPUT: AEgvbgo[ɃtH[JXݒ肵܂
//   FLAG_CLEAR_OUTPUT: AEgvbgo̕NA܂

inline BOOL Editor_OutputString(HWND hwnd, LPCWSTR szString, UINT nFlags)
{
	return (BOOL)SendMessage(hwnd, ME_OUTPUT_STRING, (WPARAM)nFlags, (LPARAM)szString);
}

// -----------------------------------------------------------------------------
// Editor_GetOutputString
//   AEgvbgo[̕擾܂
// p[^
//   hwnd:   EBhẼnh
//   cchBuf: I[܂ރobt@̃TCY
//   pBuf:   擾obt@ւ̃|C^
// ߂l
//   cchBuf0̏ꍇ̓obt@ɕKvȃTCYA0ȊȌꍇ͎gp܂

inline UINT Editor_GetOutputString(HWND hwnd, UINT cchBuf, LPWSTR pBuf)
{
	return (UINT)SendMessage(hwnd, ME_GET_OUTPUT_STRING, (WPARAM)cchBuf, (LPARAM)pBuf);
}
